import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns
import glob
from sklearn import linear_model
import numpy as np
from sklearn.model_selection import cross_val_score
from sklearn import svm
from sklearn.naive_bayes import GaussianNB
from sklearn import metrics



from sklearn.decomposition import PCA as sklearnPCA


#loading both the files
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler
from sklearn.tree import DecisionTreeClassifier

all_files = glob.glob( "*.txt")

li = []

for filename in all_files:
    df = pd.read_csv(filename, index_col=None, header=0)
    li.append(df)

data = pd.concat(li, axis=0, ignore_index=True)

#print(len(frame))

#reading data from the txt files

#data = pd.read_csv('results_noRoundaboutcases.txt')
column = list(data.columns)
print(data.head())
print("total number of column", len(data))
data = data.drop_duplicates()
print("total number of column after removing duplicates entry", len(data))


data.info()


# ploting the data and visualization

def plotdata(data,attribute):
    sns.countplot(x = attribute,data = data)
    plt.show()


plotdata(data,'DOT')

# plotdata(data,'DOT')
#
# plt.scatter(data['MaxAngle'],data['MinAngle'],c = data['isroundabout'])
# plt.title('plotting data on maximum angle and minimum angle')
# plt.show()

#
# plt.scatter(data['MaxAngle'],data['MinAngle'],c = data['NodeSize'])
# plt.title('plotting data on maximum angle and minimum angle')
# plt.show()
#HISTOGRAM PLOTS

#plotdata(data,'MaxAngle')


# plt.hist(data['MaxAngle'],bins = 40)
# plt.xlabel('minimumangle')
# plt.ylabel('count')
# plt.show()




# correlation matrix

co = data.corr()
print(co)


#normalizing the data
from sklearn import preprocessing
def scale_data(data):
    scaler = preprocessing.MinMaxScaler(feature_range=(0,1))
    data = scaler.fit_transform(data)
    data = pd.DataFrame(data)
    return data
data = scale_data(data)
data.columns = column
print(data.head())
plotdata(data,"isroundabout")


#splitting dataset into target and input feature
val =  data.values
data_X ,data_Y = val[:,:-1],val[:,-1]



# pca = sklearnPCA(n_components=2) #2-dimensional PCA
# data_pca = pd.DataFrame(pca.fit_transform(data_X))
# plt.scatter(data_pca[0],data_pca[1],c = data['isroundabout'])
# plt.show()

#Traning data
X_train , X_test ,Y_train,Y_test = train_test_split(data_X,data_Y,test_size = 0.3,shuffle = True,random_state = 41)


#Model Impleemnted
#Linear model --GINI,ACC,AUC,Spec,Sens ,ROC curves.
print('LOGISTIC REGRESSION')
lreg = linear_model.LogisticRegression(C=1e2,random_state=42,max_iter = 100)
lreg.fit(X_train,Y_train)
preds = lreg.predict(X_test)
acc = np.mean(preds==Y_test)
print('test_accuracy: ',acc)
print(cross_val_score(lreg, X_train,Y_train, cv=10))



#Decision Matrix
#decision tree classifier
print('DECISION MATRIX')
clf = DecisionTreeClassifier(criterion = 'entropy',random_state = 42)
clf.fit(X_train,Y_train)
preds = clf.predict(X_test)
acc = np.mean(preds==Y_test)
print('test_accuracy: ',acc)
print(cross_val_score(clf, X_train,Y_train, cv=10))


print('NAIVE BAYES')
clf = GaussianNB()
clf.fit(X_train,Y_train)
preds = clf.predict(X_test)
acc = np.mean(preds==Y_test)
print('test_accuracy: ',acc)
print(cross_val_score(clf, X_train,Y_train, cv=10))



print('KNeighborsClassifier')
from sklearn.neighbors import KNeighborsClassifier
clf = KNeighborsClassifier(n_neighbors=3)
clf.fit(X_train,Y_train)
preds = clf.predict(X_test)
acc = np.mean(preds==Y_test)
print('test_accuracy: ',acc)
print(cross_val_score(clf, X_train,Y_train, cv=10))



print('RandomForestClassifier')
from sklearn.ensemble import RandomForestClassifier
clf = RandomForestClassifier(n_estimators=10)
clf.fit(X_train,Y_train)
preds = clf.predict(X_test)
acc = np.mean(preds==Y_test)
print('test_accuracy: ',acc)
print(cross_val_score(clf, X_train,Y_train, cv=10))

# print('SUPPORT VECTOR CLASSIFIER')
# clf = svm.SVC(kernel='linear',C = 1.0)
# clf.fit(X_train,Y_train)
# preds = clf.predict(X_test)
# acc = np.mean(preds == Y_test)
# print('test_accuracy :',acc)
# print(cross_val_score(clf, X_train,Y_train, cv=10))


#Clustering analysis








