# Supplementary code for data exploration and analysis of the paper: Assessing the physicochemical and microbiological condition of surface waters in Urab-Colombia: Impact of human activities and agro-industry

**Source code citation:** Vctor H. Aristizabal-Tique, Diana M. Gmez-Gallego, Ivis T. Ramos-Hernndez, Yamilet Arcos-Arango, Diana N. Polanco-Echeverry, Francisco J. Vlez-Hoyos (2023), Supplementary code for data exploration and analysis of the paper: Assessing the physicochemical and microbiological condition of surface waters in Urab-Colombia: Impact of human activities and agro-industry. [Source Code]. Code Ocean.

## Code in Python and datasets for the Paper:

** Vctor H. Aristizabal-Tique, Diana M. Gmez-Gallego, Ivis T. Ramos-Hernndez, Yamilet Arcos-Arango, Diana N. Polanco-Echeverry, Francisco J. Vlez-Hoyos (2023), Assessing the physicochemical and microbiological condition of surface waters in Urab-Colombia: Impact of human activities and agro-industry, submitted, 2024.**

**Abstract** - Water resources in the Urab region in Colombia, one of the most important bananaproducing regions for worldwide consumption, face significant challenges due to agroindustrial activities, population growth, untreated wastewater discharge, and excessive groundwater usage. This study aimed to assess the physicochemical and microbiological properties of surface waters in the Urab region, analyzing the impact of agro-industrial activities and human intervention on water quality. The evaluation included a correlation analysis of multiple water quality parameters measured in ten significant rivers of the region. The findings revealed overall water pollution, which could be associated with the lack of wastewater treatment systems in nearby communities and indicated potential seawater intrusion due to groundwater overexploitation from human and agricultural activities. Among the studied rivers, the Apartad River displayed the poorest water quality, while the Len River exhibited better conditions, benefiting from less human interference and natural ecosystems.

## Code, Data, Results

**Main script in Jupyter:**
DataExplorationAnalysisScript.ipynb

** Dataset of the physicochemical and microbiological parameters at the sampling points of the different rivers:**
SamplingPointsPhysicochemicalParameters.xlsx
SamplingPointsPhysicochemicalParameters_WithoutOutliers.xlsx

**Results:**
Figure files of histograms, boxplots, scattered data and linear regression models fit with a 95% confidence interval size, heatmap of Spearman correlation and p-value for datasets with and without outliers.

Files with the Spearman correlation and p-value matrices for datasets with and without outliers: OrigData_SpearmanRhoMatrix.xlsx, 
OrigData_PvalueMatrix.xlsx, 
NewData_SpearmanRhoMatrix.xlsx, 
NewData_PvalueMatrix.xlsx

## Environment and Dependencies

For initiating the Python script on the desktop version of Jupyter Notebook, please run the file DataExplorationAnalysisScript.ipynb.

On Code Ocean, pressing run will execute DataExplorationAnalysisScript.ipynb, which will throw the results files described above.

